/***************************************************
*  File			: menue.c
*  Autor 		: D.Nolte
*  Date 		: 17.11.2005
*  Version		: 0.0.9
*  -------------------------------------------------
*  Discription	:
*  
*  
*  -------------------------------------------------
*  Changed :
*  Date / Autor / comment.
*
****************************************************/
#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#ifndef _menue_H
	#include "menue.h"
#endif

#ifndef _key_H_
	#include "key.h"
#endif

#ifndef _lcd_H_
	#include "lcd.h"
#endif

#ifndef _delays_h_
	#include "delays.h"
#endif

#ifndef _datum_H_
	#include "datum.h"		//Calendar and time
#endif

#ifndef _debug_H_
	#include "debug.h"
#endif

#ifndef _main_H_			//Main aufruf
	#include "main.h"		
#endif

#ifndef _STDLIB_H_			//Main aufruf
	#include "stdlib.h"		
#endif

ProgHandle_t MH;
TimeSet_t PM[Anzahl_Programme+1];

//Filescope globale variable
unsigned char temp1[16]; 		//Fr Zeichenkette Zeit und Datum
unsigned char temp2[16];
char *temp3[16];				//Test um sprintf zu sparen
char *str1 = "Nr:00|Auf:00:00";//Test um sprintf zu sparen

char *str2 = " TT  |Zu :00:00";
char *str3 = "Datum TT.MM.JJJJ";
char *str4 = "Zeit TT HH:MM:SS";
char *str5 = "TT HH:MM:SS";
char *str10 = "Mo";
char *str11 = "Di";
char *str12 = "Mi";
char *str13 = "D0";
char *str14 = "Fr";
char *str15 = "Sa";
char *str16 = "So";


enum Text_day {MO=0,DI,MI,DO,FR,SA,SO};
//----------------------------------------------------------------------------
// Diese funktion dient zum hoch und runterzhlen einer Zhal 
// keycode	= Tastencode 
//			  Tastencode 0x01 = Zhlwert + 1
//			  Tastencode 0x02 = Zhlwert - 1
// digit 	= Variable des Zhlwertes
// llimit	= Unteres limit
// hlimit	= oberes limit
//----------------------------------------------------------------------------
int digitcount (char keycode,int digit,int llimit,int hlimit){
   if (keycode == 0x01) ++digit;
   if (keycode == 0x02) --digit;
   if (digit > hlimit) digit = llimit;
   if (digit < llimit) digit = hlimit;
   return digit;
};
//----------------------------------------------------------------------------
//
//
//----------------------------------------------------------------------------
void ProgramInput (void){
	LCD_clear();
	// Aufbau 1 Zeile
	//
	//str1[3] = MH.List_prog;
	LCD_sprint(LCD_line1,0x00,str1); //Test sprintf sparen
	//sprintf(temp1,"Nr:%2d|Auf:%2d:%2d",MH->List_prog,PM[MH->List_prog].start_H,PM[MH->List_prog].start_M);
	//LCD_print(LCD_line1,0x00,temp1);
	// Aufbau 2 Zeile

	switch (PM[MH.List_prog].day){
		case MO :	//sprintf(temp2,"Mo");
					break;
		case DI :	//sprintf(temp2,"Di");
					break;
		case MI :	//sprintf(temp2,"Mi");
					break;
		case DO :	//sprintf(temp2,"Do");
					break;
		case FR :	//sprintf(temp2,"Fr");
					break;
		case SA :	//sprintf(temp2,"Sa");
					break;
		case SO :	//sprintf(temp2,"So");
					break;
		default :   break;
	};//end switch
	//sprintf(temp1,"%2s  |Zu :%2d:%2d",temp2,PM[MH.List_prog].end_H,PM[MH.List_prog].end_M);
	LCD_print(LCD_line2,0x01,temp1);
	
	if (!((MH.Act_key == 0x03) && (MH.List_count == 0))){
		//------------------------------------------------------------------
		// Positioniere cursor im Display an die zu Edietierende Stelle
		//------------------------------------------------------------------
		//Wenn List_index == 0x01 kann gezhlt werden und die 
		//entsprechenden stellen die gendert werden sollen
		//werden angesprungen
		if (MH.List_index == 0x01) MH.List_count = digitcount(MH.Act_key,MH.List_count,0,6);
		//Cursor positionieren
		switch (MH.List_count){
			case 0x00 :		LCD_cursor(1,1);
							break;
			case 0x01 :		LCD_cursor(1,4);
							break;
			case 0x02 :		LCD_cursor(2,2);
							break;
			case 0x03 :		LCD_cursor(1,11);
							break;
			case 0x04 :		LCD_cursor(1,14);
							break;
			case 0x05 :		LCD_cursor(2,11);
							break;
			case 0x06 :		LCD_cursor(2,14);
							break;
			default: 		break;
		}//end switch
		if ((MH.Act_key == 0x03) && (MH.List_index == 0x01)) MH.List_index = 0x02;
		if (!(MH.Act_key == 0x03) && (MH.List_index == 0x02)) MH.List_index = 0x03;
		if ((MH.Act_key == 0x03) && (MH.List_index == 0x03)) MH.List_index = 0x04;
		if (!(MH.Act_key == 0x03) && (MH.List_index == 0x04)) MH.List_index = 0x01;
		
		if (MH.List_index > 0x01) {
			switch (MH.List_count){
				case 0x00 :		break;
				case 0x01 :		MH.List_prog = digitcount(MH.Act_key,MH.List_prog,0,Anzahl_Programme);
								break; //reserve
				case 0x02 :		PM[MH.List_prog].day = digitcount(MH.Act_key,PM[MH.List_prog].day,0,6);
								break;
				case 0x03 :		PM[MH.List_prog].start_H = digitcount(MH.Act_key,PM[MH.List_prog].start_H,0,23);
								break;
				case 0x04 :		PM[MH.List_prog].start_M = digitcount(MH.Act_key,PM[MH.List_prog].start_M,0,59);
								break;
				case 0x05 :		PM[MH.List_prog].end_H = digitcount(MH.Act_key,PM[MH.List_prog].end_H,0,23);
								break;
				case 0x06 :		PM[MH.List_prog].end_M = digitcount(MH.Act_key,PM[MH.List_prog].end_M,0,59);
								break;
				default: 		break;
			}	
		}
	}
	else MH.active=0;
}
//----------------------------------------------------------------------------
//
//
//----------------------------------------------------------------------------
void DT_Input(){
    DateTime_t DT;
	LCD_clear();
	//------------------------------------------------------------
	// Anzeige Datum und Uhrzeit
	//------------------------------------------------------------
	DT = get_DT();	//holte Aktuelle Uhrzeit 
	sprintf(temp1,"Datum %2d.%2d.%4d",DT.day,DT.month,DT.year);
	LCD_print(LCD_line1,0x00,temp1);
	switch (DT.weekday){
				case MO :	sprintf(temp2,"Mo");
							break;
				case DI :	sprintf(temp2,"Di");
							break;
				case MI :	sprintf(temp2,"Mi");
						break;
				case DO :	sprintf(temp2,"Do");
							break;
				case FR :	sprintf(temp2,"Fr");
							break;
				case SA :	sprintf(temp2,"Sa");
							break;
				case SO :	sprintf(temp2,"So");
							break;
				default :   break;
			};//end switch
	sprintf(temp1,"Zeit %2s %2d:%2d:%2d",temp2,DT.hour,DT.minute,DT.second);
	LCD_print(LCD_line2,0x00,temp1);		
	if (!((MH.Act_key == 0x03) && (MH.List_count == 0))) {
		//------------------------------------------------------------------
		// Positioniere cursor im Display an die zu Edietierende Stelle
		//------------------------------------------------------------------
		//Wenn List_index == 0x01 kann gezhlt werden und die 
		//entsprechenden stellen die gendert werden sollen
		//werden angesprungen
		if (MH.List_index == 0x01) MH.List_count = digitcount(MH.Act_key,MH.List_count,0,6);
		switch (MH.List_count){
				case 0 :		LCD_cursor(1,0);
								break; //reserve
				case 1 :		LCD_cursor(1,7);
								break;
				case 2 :		LCD_cursor(1,10);
								break;
				case 3 :		LCD_cursor(1,15);
								break;
				case 4 :		LCD_cursor(2,9);
								break;
				case 5 :		LCD_cursor(2,12);
								break;
				case 6 :		LCD_cursor(2,15);
								break;
				default: 		break;
		}//end switch
		if ((MH.Act_key == 0x03) && (MH.List_index == 0x01)) MH.List_index = 0x02;
		if (!(MH.Act_key == 0x03) && (MH.List_index == 0x02)) MH.List_index = 0x03;
		if ((MH.Act_key == 0x03) && (MH.List_index == 0x03)) MH.List_index = 0x04;
		if (!(MH.Act_key == 0x03) && (MH.List_index == 0x04)) MH.List_index = 0x01;
		//---------------------------------------------------------------------------
		// Zhle den jeweiligen wert hoch/runter wo der cursor steht
		//---------------------------------------------------------------------------
		if (MH.List_index > 0x01) {
			switch (MH.List_count){
				case 0 :		break; //reserve
				case 1 :		DT.day = digitcount(MH.Act_key,DT.day,1,31);
								break;
				case 2 :		DT.month = digitcount(MH.Act_key,DT.month,1,12);
								break;
				case 3 :		DT.year = digitcount(MH.Act_key,DT.year,1900,3000);
								break;
				case 4 :		DT.hour = digitcount(MH.Act_key,DT.hour,0,23);
								break;
				case 5 :		DT.minute = digitcount(MH.Act_key,DT.minute,0,59);
								break;
				case 6 :		DT.second = digitcount(MH.Act_key,DT.second,0,59);
								break;
				default: 		break;
			}				
			set_DT(DT);	
		}		
	}
	else MH.active = 0;
}
//----------------------------------------------------------------------------
//
//
//----------------------------------------------------------------------------
void Menue(){
    char key_press=0;
	//Stelle fest ob sich die gedrckte Taste gendert hat
	if (MH.Act_key != MH.Old_key) {
		MH.Old_key = MH.Act_key;
		key_press=1;
	}
	
	//DTime =get_DT();//Pointer auf Aktuelle Zeit
	//Menue nur weiterschalten wenn nichts Aktive ist
	if (!MH.active && key_press) MH.Act_menue = digitcount(MH.Act_key,MH.Act_menue,0,5);
	//-------------------------------------------------------------------------
	//  LCD-Disply Anzeige --- Debug Anzeige ---
    //  Zeigt die Debug informationen an.
    //------------------------------------------------------------------------- 
	if (MH.Act_menue == 0 && (MH.old_second !=DateAndTime.second)){
		//LCD_clear();
		//LCD_print(LCD_line1,0x00,debug1);
		//LCD_print(LCD_line2,0x00,debug2);
		MH.old_second = DateAndTime.second;
	}
	//-------------------------------------------------------------------------
	//  LCD-Disply Anzeige --- Staus Anzeige Automatik / Uhrzeit ---
    //  Zeigt den Status der Automatik sowie die Uhrzeit an.
    //------------------------------------------------------------------------- 
	/*else if (MH.Act_menue == 1 && (MH.old_second !=DateAndTime.second)){		//Uhrzeit/Datum
		LCD_clear();
		if (MH.start) {
			LCD_print(LCD_line1,0x00,"Automatik An");
		}
		else {
			LCD_print(LCD_line1,0x00,"Automatik Aus");
		}
		
		switch (DateAndTime.weekday){
				case MO :	//sprintf(temp2,"Mo");
							break;
				case DI :	//sprintf(temp2,"Di");
							break;
				case MI :	//sprintf(temp2,"Mi");
						break;
				case DO :	//sprintf(temp2,"Do");
							break;
				case FR :	//sprintf(temp2,"Fr");
							break;
				case SA :	//sprintf(temp2,"Sa");
							break;
				case SO :	//sprintf(temp2,"So");
							break;
				default :   break;
		};//end switch
		
		//sprintf(temp1,"%2s %2d:%2d:%2d",temp2,DateAndTime.hour,DTime.minute,DTime.second);
		//LCD_print(LCD_line2,0x00,temp1);
		MH.old_second = DateAndTime.second;
	*/
	//-------------------------------------------------------------------------
	//  LCD-Disply Anzeige --- Automatik Start/Stop ---
    //  Schaltet die Automatik ein.
    //------------------------------------------------------------------------- 
	/*else if (MH.Act_menue == 2 && key_press){		//Automatik Start
	    if (MH.start){
			LCD_clear();
			LCD_print(LCD_line1,0x00,"Automatik");
			LCD_print(LCD_line2,0x00,"Ausschalten");
			if (MH.Act_key == 0x03 && key_press) MH.start = 0;
		}
		else {
			LCD_clear();
			LCD_print(LCD_line1,0x00,"Automatik");
			LCD_print(LCD_line2,0x00,"Einschalten");
			if (MH.Act_key == 0x03 && key_press) MH.start =1;
		}
	}*/
	//-------------------------------------------------------------------------
	//  LCD-Display Anziege --- Programm eingeben ---
	//  Ruft die Funktion zum eingeben der Schaltprogramme auf
	//-------------------------------------------------------------------------
	/*else if (MH.Act_menue == 3  && key_press) {			//Programm Einstellen
		if (MH.active ){				
			//ProgramInput();
		}
		else {
			LCD_clear();
			LCD_print(LCD_line1,0x00,"Programme");
			LCD_print(LCD_line2,0x00,"Eingeben");
			if (MH.Act_key == 0x03) MH.active = 1;
		}
	}*/
	//-------------------------------------------------------------------------
	//  LCD-Disply Anzeige --- Automatik Stop ---
    //  Schaltet die Automatik aus.
    //------------------------------------------------------------------------- 
	/*else if (MH.Act_menue == 4  && key_press){		//Automatik Stop
		if (!MH.start){
			LCD_clear();
			LCD_print(LCD_line1,0x00,"Es wird");
			LCD_print(LCD_line2,0x00,"gespeichert");
		}
		else {
			LCD_clear();
			LCD_print(LCD_line1,0x00,"Einstellung");
			LCD_print(LCD_line2,0x00,"Speichern");
		}
	}*/
	//-------------------------------------------------------------------------
	//  LCD-Disply Anzeige --- Uhrzeit/Datum einstellen ---
    //  Ruft die Funktion zum Uhrzeit/Datum einstellen auf.
    //------------------------------------------------------------------------- 
	else if (MH.Act_menue == 5  && key_press){		//Uhrzeit/Datum
		//if (MH.active){
			//DT_Input();
		//}
		//else {
			LCD_clear();
			LCD_print(LCD_line1,0x00,"Uhrzeit/Datum");
			//LCD_print(LCD_line2,0x00,"Einstellen");
			//if (MH.Act_key == 0x03 && key_press) MH.active = 1;
		//}
	}
	else if ((MH.Act_menue > 5) || (MH.Act_menue < 0)) MH.Act_menue = 0;
}
