/***************************************************
*  File			: motor.c
*  Autor 		: D.Nolte
*  Date 		: 16.12.2005
*  Version		: 0.0.1
*  -------------------------------------------------
*  Discription	:
*  
*  
*  -------------------------------------------------
*  Changed :
*  Date / Autor / comment.
*
****************************************************/
#ifndef _AVR_IO_H_
	#include <avr/io.h>
#endif

#ifndef _STDLIB_H_
	#include <stdlib.h>
#endif

#ifndef _STRING_H_
	#include <string.h>
#endif

#ifndef _STDIO_H_
	#include <stdio.h>
#endif

#ifndef _debug_H_
	#include <debug.h>
#endif

#ifndef _menue_H
	#include "menue.h"
#endif

#ifndef _motor_H_
	#include "motor.h"		//Motor Steuerung
#endif

#ifndef _delays_h_
	#include "delays.h"
#endif

char volatile lock; //Test

int volatile LsWOpen;
int volatile LsWClose;
int volatile LsLRelease;
int volatile LsLOpen;
int volatile LsLClose;

//---------------------------------------------------------
// Einlesen der Endschalter Signale
//---------------------------------------------------------
static inline void Ls_input(void){
	LsWOpen  = ( input_w >> ls_w_open) & 0x01;
	LsWClose = ( input_w >> ls_w_closed) & 0x01;
	LsLRelease = ( input_l >> ls_l_released) & 0x01;
	LsLOpen    = ( input_l >> ls_l_open) & 0x01;
	LsLClose   = ( input_l >> ls_l_closed) & 0x01;
}

static inline void motor_off (char motor){
	output_port &= ~motor;
}

static inline void motor_on (char motor){
	output_port |= motor;
}

void Open_w(char cmd){
	Ls_input();// Endschalter einlesen
	//Setze Richtung zum ffnen
		
	if (cmd == 0x01 && LsLClose ) {
		motor_on(motor_l_dir);
		motor_on(motor_l_on);
		if (LsLRelease) MH.released = 0;
	}
	else if (cmd == 0x02 && LsLOpen) {
		motor_off(motor_l_dir);
		motor_on(motor_l_on);
		if (LsLRelease) MH.released = 1;
	}
	else {
		motor_off(motor_l_on);
		motor_off(motor_l_dir);
	}
	
	if (cmd == 0x03 && LsWClose) {
		motor_on(motor_w_dir);
		motor_on(motor_w_on);
	}
	else if (cmd == 0x04 && LsWOpen && MH.released) {
		motor_off(motor_w_dir);
		motor_on(motor_w_on);
	}
	else {
		motor_off(motor_w_on);
		motor_off(motor_w_dir);
	}
	
	//motor_on(motor_w_dir);
    
	//if ((MH->start && !MH->released) || (MH->released && (cmd == 1) && !LsLOpen)) motor_on(motor_l_on);
	//else motor_off(motor_l_on);
	
	//if (ls_l_open && !ls_w_open) motor_on(motor_w_on);
	//else motor_off(motor_w_on);
}


